create_clock -period 5.0 -name fpga_clk [get_ports fpga_clk]

# Constrains PLL outputs.  One output has 90 degree phase-shift for transmit clock
derive_pll_clocks

derive_clock_uncertainty


################### FPGA -> 5675a Interface ####################
# Put a generated clock on output clock port to be referenced by set_output_delay constraints
create_generated_clock -source [get_pins {inst1|altpll_component|auto_generated|pll1|clk[1]}] -name ssync_tx_clk_ext [get_ports {ssync_tx_clk}]

# TI 5675a Datasheet has a Tsu of 1.5ns and Th of 0ns.  Tsu goes directly to the max external delay, and -Th goes directly to the min external delay
set dac_tsu 1.5
set dac_th -0.0 ;# The negative sign isn't doing anything, but necessary if Th is not 0.

# The board skew need to be accounted for.  Positive means data is longer than clk, negative means it is shorter than clk.
set board_data2clk_skew_max 0.05
set board_data2clk_skew_min -0.05

# Now just add the board skew and DAC skew to calculate external delays:
set ssync_out_max [expr $dac_tsu + $board_data2clk_skew_max] ;# 1.5 + 0.1 = 1.6
set ssync_out_min [expr $dac_th + $board_data2clk_skew_min] ;# -0.0 + -0.1 = -0.1

set_output_delay -clock ssync_tx_clk_ext -max $ssync_out_max [get_ports {ssync_tx_data[*]}]
set_output_delay -clock ssync_tx_clk_ext -min $ssync_out_min [get_ports {ssync_tx_data[*]}]
set_output_delay -clock ssync_tx_clk_ext -max $ssync_out_max [get_ports {ssync_tx_data[*]}] -clock_fall -add_delay
set_output_delay -clock ssync_tx_clk_ext -min $ssync_out_min [get_ports {ssync_tx_data[*]}] -clock_fall -add_delay
################################################################
